diff --git a/src/mongo/db/pipeline/SConscript b/src/mongo/db/pipeline/SConscript
index dff5f65999..e6a9d1f2db 100644
--- a/src/mongo/db/pipeline/SConscript
+++ b/src/mongo/db/pipeline/SConscript
@@ -71,12 +71,12 @@ env.Library(
 env.Library(
     target='expression_context',
     source=[
-        'expression.cpp',
+        'expression/expression.cpp',
         'expression_context.cpp',
-        'expression_function.cpp',
-        'expression_js_emit.cpp',
-        'expression_test_api_version.cpp',
-        'expression_trigonometric.cpp',
+        'expression/expression_function.cpp',
+        'expression/expression_js_emit.cpp',
+        'expression/expression_test_api_version.cpp',
+        'expression/expression_trigonometric.cpp',
         'javascript_execution.cpp',
         'make_js_function.cpp',
         'variables.cpp',
@@ -119,21 +119,21 @@ env.Library(
 env.Library(
     target='accumulator',
     source=[
-        'accumulation_statement.cpp',
-        'accumulator_add_to_set.cpp',
-        'accumulator_avg.cpp',
-        'accumulator_covariance.cpp',
-        'accumulator_exp_moving_avg.cpp',
-        'accumulator_first.cpp',
-        'accumulator_integral.cpp',
-        'accumulator_js_reduce.cpp',
-        'accumulator_last.cpp',
-        'accumulator_merge_objects.cpp',
-        'accumulator_min_max.cpp',
-        'accumulator_push.cpp',
-        'accumulator_rank.cpp',
-        'accumulator_std_dev.cpp',
-        'accumulator_sum.cpp',
+        'accumulator/accumulation_statement.cpp',
+        'accumulator/accumulator_add_to_set.cpp',
+        'accumulator/accumulator_avg.cpp',
+        'accumulator/accumulator_covariance.cpp',
+        'accumulator/accumulator_exp_moving_avg.cpp',
+        'accumulator/accumulator_first.cpp',
+        'accumulator/accumulator_integral.cpp',
+        'accumulator/accumulator_js_reduce.cpp',
+        'accumulator/accumulator_last.cpp',
+        'accumulator/accumulator_merge_objects.cpp',
+        'accumulator/accumulator_min_max.cpp',
+        'accumulator/accumulator_push.cpp',
+        'accumulator/accumulator_rank.cpp',
+        'accumulator/accumulator_std_dev.cpp',
+        'accumulator/accumulator_sum.cpp',
         'window_function/window_bounds.cpp',
         'window_function/window_function_covariance.cpp',
         'window_function/window_function_count.cpp',
@@ -169,7 +169,7 @@ env.Library(
 env.Library(
     target='document_source_mock',
     source=[
-        'document_source_mock.cpp',
+        'document_source/document_source_mock.cpp',
         'process_interface/stub_lookup_single_document_process_interface.cpp',
         ],
     LIBDEPS=[
@@ -229,50 +229,50 @@ pipelineEnv.InjectThirdParty(libraries=['snappy'])
 pipelineEnv.Library(
     target='pipeline',
     source=[
-        'document_source.cpp',
-        'document_source_add_fields.cpp',
-        'document_source_bucket.cpp',
-        'document_source_bucket_auto.cpp',
-        'document_source_coll_stats.cpp',
-        'document_source_count.cpp',
-        'document_source_current_op.cpp',
-        'document_source_densify.cpp',
-        'document_source_exchange.cpp',
-        'document_source_facet.cpp',
-        'document_source_geo_near.cpp',
-        'document_source_graph_lookup.cpp',
-        'document_source_group.cpp',
-        'document_source_index_stats.cpp',
-        'document_source_internal_inhibit_optimization.cpp',
-        'document_source_internal_shard_filter.cpp',
-        'document_source_internal_split_pipeline.cpp',
-        'document_source_limit.cpp',
-        'document_source_list_cached_and_active_users.cpp',
-        'document_source_list_local_sessions.cpp',
-        'document_source_list_sessions.cpp',
-        'document_source_lookup.cpp',
-        'document_source_match.cpp',
-        'document_source_merge.cpp',
-        'document_source_operation_metrics.cpp',
-        'document_source_out.cpp',
-        'document_source_plan_cache_stats.cpp',
-        'document_source_project.cpp',
-        'document_source_queue.cpp',
-        'document_source_redact.cpp',
-        'document_source_replace_root.cpp',
-        'document_source_sample.cpp',
-        'document_source_sample_from_random_cursor.cpp',
-        'document_source_sequential_document_cache.cpp',
-        'document_source_set_window_fields.cpp',
-        'document_source_single_document_transformation.cpp',
-        'document_source_skip.cpp',
-        'document_source_sort.cpp',
-        'document_source_sort_by_count.cpp',
-        'document_source_tee_consumer.cpp',
-        'document_source_union_with.cpp',
-        'document_source_unwind.cpp',
-        'document_source_internal_unpack_bucket.cpp',
-        'document_source_internal_convert_bucket_index_stats.cpp',
+        'document_source/document_source.cpp',
+        'document_source/document_source_add_fields.cpp',
+        'document_source/document_source_bucket.cpp',
+        'document_source/document_source_bucket_auto.cpp',
+        'document_source/document_source_coll_stats.cpp',
+        'document_source/document_source_count.cpp',
+        'document_source/document_source_current_op.cpp',
+        'document_source/document_source_densify.cpp',
+        'document_source/document_source_exchange.cpp',
+        'document_source/document_source_facet.cpp',
+        'document_source/document_source_geo_near.cpp',
+        'document_source/document_source_graph_lookup.cpp',
+        'document_source/document_source_group.cpp',
+        'document_source/document_source_index_stats.cpp',
+        'document_source/document_source_internal_inhibit_optimization.cpp',
+        'document_source/document_source_internal_shard_filter.cpp',
+        'document_source/document_source_internal_split_pipeline.cpp',
+        'document_source/document_source_limit.cpp',
+        'document_source/document_source_list_cached_and_active_users.cpp',
+        'document_source/document_source_list_local_sessions.cpp',
+        'document_source/document_source_list_sessions.cpp',
+        'document_source/document_source_lookup.cpp',
+        'document_source/document_source_match.cpp',
+        'document_source/document_source_merge.cpp',
+        'document_source/document_source_operation_metrics.cpp',
+        'document_source/document_source_out.cpp',
+        'document_source/document_source_plan_cache_stats.cpp',
+        'document_source/document_source_project.cpp',
+        'document_source/document_source_queue.cpp',
+        'document_source/document_source_redact.cpp',
+        'document_source/document_source_replace_root.cpp',
+        'document_source/document_source_sample.cpp',
+        'document_source/document_source_sample_from_random_cursor.cpp',
+        'document_source/document_source_sequential_document_cache.cpp',
+        'document_source/document_source_set_window_fields.cpp',
+        'document_source/document_source_single_document_transformation.cpp',
+        'document_source/document_source_skip.cpp',
+        'document_source/document_source_sort.cpp',
+        'document_source/document_source_sort_by_count.cpp',
+        'document_source/document_source_tee_consumer.cpp',
+        'document_source/document_source_union_with.cpp',
+        'document_source/document_source_unwind.cpp',
+        'document_source/document_source_internal_unpack_bucket.cpp',
+        'document_source/document_source_internal_convert_bucket_index_stats.cpp',
         'pipeline.cpp',
         'semantic_analysis.cpp',
         'sequential_document_cache.cpp',
@@ -342,18 +342,18 @@ env.Library(
     source=[
         'change_stream_document_diff_parser.cpp',
         'change_stream_helpers_legacy.cpp',
-        'document_source_change_stream.cpp',
-        'document_source_change_stream_check_invalidate.cpp',
-        'document_source_change_stream_check_resumability.cpp',
-        'document_source_change_stream_check_topology_change.cpp',
-        'document_source_change_stream_close_cursor.cpp',
-        'document_source_change_stream_ensure_resume_token_present.cpp',
-        'document_source_change_stream_handle_topology_change.cpp',
-        'document_source_change_stream_lookup_post_image.cpp',
-        'document_source_change_stream_lookup_pre_image.cpp',
-        'document_source_change_stream_oplog_match.cpp',
-        'document_source_change_stream_transform.cpp',
-        'document_source_change_stream_unwind_transactions.cpp',
+        'change_stream/document_source_change_stream.cpp',
+        'change_stream/document_source_change_stream_check_invalidate.cpp',
+        'change_stream/document_source_change_stream_check_resumability.cpp',
+        'change_stream/document_source_change_stream_check_topology_change.cpp',
+        'change_stream/document_source_change_stream_close_cursor.cpp',
+        'change_stream/document_source_change_stream_ensure_resume_token_present.cpp',
+        'change_stream/document_source_change_stream_handle_topology_change.cpp',
+        'change_stream/document_source_change_stream_lookup_post_image.cpp',
+        'change_stream/document_source_change_stream_lookup_pre_image.cpp',
+        'change_stream/document_source_change_stream_oplog_match.cpp',
+        'change_stream/document_source_change_stream_transform.cpp',
+        'change_stream/document_source_change_stream_unwind_transactions.cpp',
     ],
     LIBDEPS=[
         '$BUILD_DIR/mongo/db/pipeline/pipeline',
@@ -376,16 +376,16 @@ env.Library(
 env.Library(
     target='document_sources_idl',
     source=[
-        'document_source_change_stream.idl',
-        'document_source_coll_stats.idl',
-        'document_source_list_sessions.idl',
-        'document_source_merge.idl',
-        'document_source_merge_modes.idl',
-        'document_source_merge_spec.cpp',
-        'document_source_parsing_validators.cpp',
-        'document_source_replace_root.idl',
-        'document_source_set_window_fields.idl',
-        'document_source_union_with.idl',
+        'change_stream/document_source_change_stream.idl',
+        'document_source/document_source_coll_stats.idl',
+        'document_source/document_source_list_sessions.idl',
+        'document_source/document_source_merge.idl',
+        'document_source/document_source_merge_modes.idl',
+        'document_source/document_source_merge_spec.cpp',
+        'document_source/document_source_parsing_validators.cpp',
+        'document_source/document_source_replace_root.idl',
+        'document_source/document_source_set_window_fields.idl',
+        'document_source/document_source_union_with.idl',
         'exchange_spec.idl',
         'resume_token.cpp',
         'storage_stats_spec.idl',
@@ -404,46 +404,46 @@ env.Library(
 env.CppUnitTest(
     target='db_pipeline_test',
     source=[
-        'accumulator_js_test.cpp' if get_option('js-engine') != 'none' else [],
-        'accumulator_test.cpp',
+        'accumulator/accumulator_js_test.cpp' if get_option('js-engine') != 'none' else [],
+        'accumulator/accumulator_test.cpp',
         'aggregation_request_test.cpp',
         'dependencies_test.cpp',
         'dispatch_shard_pipeline_test.cpp',
         'document_path_support_test.cpp',
-        'document_source_add_fields_test.cpp',
-        'document_source_bucket_auto_test.cpp',
-        'document_source_bucket_test.cpp',
-        'document_source_change_stream_test.cpp',
-        'document_source_check_resume_token_test.cpp',
-        'document_source_count_test.cpp',
-        'document_source_current_op_test.cpp',
-        'document_source_densify_test.cpp',
-        'document_source_exchange_test.cpp',
-        'document_source_facet_test.cpp',
-        'document_source_geo_near_test.cpp',
-        'document_source_graph_lookup_test.cpp',
-        'document_source_group_test.cpp',
-        'document_source_internal_shard_filter_test.cpp',
-        'document_source_internal_split_pipeline_test.cpp',
-        'document_source_limit_test.cpp',
-        'document_source_change_stream_lookup_post_image_test.cpp',
-        'document_source_lookup_test.cpp',
-        'document_source_match_test.cpp',
-        'document_source_merge_cursors_test.cpp',
-        'document_source_merge_test.cpp',
-        'document_source_mock_test.cpp',
-        'document_source_out_test.cpp',
-        'document_source_plan_cache_stats_test.cpp',
-        'document_source_project_test.cpp',
-        'document_source_redact_test.cpp',
-        'document_source_replace_root_test.cpp',
-        'document_source_sample_test.cpp',
-        'document_source_sequential_document_cache_test.cpp',
-        'document_source_set_window_fields_test.cpp',
-        'document_source_skip_test.cpp',
-        'document_source_sort_by_count_test.cpp',
-        'document_source_sort_test.cpp',
-        'document_source_union_with_test.cpp',
+        'document_source/document_source_add_fields_test.cpp',
+        'document_source/document_source_bucket_auto_test.cpp',
+        'document_source/document_source_bucket_test.cpp',
+        'change_stream/document_source_change_stream_test.cpp',
+        'document_source/document_source_check_resume_token_test.cpp',
+        'document_source/document_source_count_test.cpp',
+        'document_source/document_source_current_op_test.cpp',
+        'document_source/document_source_densify_test.cpp',
+        'document_source/document_source_exchange_test.cpp',
+        'document_source/document_source_facet_test.cpp',
+        'document_source/document_source_geo_near_test.cpp',
+        'document_source/document_source_graph_lookup_test.cpp',
+        'document_source/document_source_group_test.cpp',
+        'document_source/document_source_internal_shard_filter_test.cpp',
+        'document_source/document_source_internal_split_pipeline_test.cpp',
+        'document_source/document_source_limit_test.cpp',
+        'change_stream/document_source_change_stream_lookup_post_image_test.cpp',
+        'document_source/document_source_lookup_test.cpp',
+        'document_source/document_source_match_test.cpp',
+        'document_source/document_source_merge_cursors_test.cpp',
+        'document_source/document_source_merge_test.cpp',
+        'document_source/document_source_mock_test.cpp',
+        'document_source/document_source_out_test.cpp',
+        'document_source/document_source_plan_cache_stats_test.cpp',
+        'document_source/document_source_project_test.cpp',
+        'document_source/document_source_redact_test.cpp',
+        'document_source/document_source_replace_root_test.cpp',
+        'document_source/document_source_sample_test.cpp',
+        'document_source/document_source_sequential_document_cache_test.cpp',
+        'document_source/document_source_set_window_fields_test.cpp',
+        'document_source/document_source_skip_test.cpp',
+        'document_source/document_source_sort_by_count_test.cpp',
+        'document_source/document_source_sort_test.cpp',
+        'document_source/document_source_union_with_test.cpp',
         'document_source_internal_unpack_bucket_test/extract_or_build_project_to_internalize_test.cpp',
         'document_source_internal_unpack_bucket_test/create_predicates_on_bucket_level_field_test.cpp',
         'document_source_internal_unpack_bucket_test/extract_project_for_pushdown_test.cpp',
@@ -453,26 +453,26 @@ env.CppUnitTest(
         'document_source_internal_unpack_bucket_test/pushdown_computed_meta_projections_test.cpp',
         'document_source_internal_unpack_bucket_test/sample_reorder_test.cpp',
         'document_source_internal_unpack_bucket_test/sort_reorder_test.cpp',
-        'document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp',
         'document_source_internal_unpack_bucket_test/unpack_bucket_exec_test.cpp',
-        'document_source_unwind_test.cpp',
-        'expression_and_test.cpp',
-        'expression_compare_test.cpp',
+        'document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp',
+        'document_source/document_source_unwind_test.cpp',
+        'expression/expression_and_test.cpp',
+        'expression/expression_compare_test.cpp',
         'expression_context_test.cpp',
-        'expression_convert_test.cpp',
-        'expression_date_test.cpp',
-        'expression_field_path_test.cpp',
-        'expression_find_internal_test.cpp',
-        'expression_javascript_test.cpp' if get_option('js-engine') != 'none' else [],
-        'expression_nary_test.cpp',
-        'expression_object_test.cpp',
-        'expression_or_test.cpp',
-        'expression_replace_test.cpp',
-        'expression_test.cpp',
-        'expression_test_api_version_test.cpp',
-        'expression_trigonometric_test.cpp',
-        'expression_trim_test.cpp',
-        'expression_walker_test.cpp',
+        'expression/expression_convert_test.cpp',
+        'expression/expression_date_test.cpp',
+        'expression/expression_field_path_test.cpp',
+        'expression/expression_find_internal_test.cpp',
+        'expression/expression_javascript_test.cpp' if get_option('js-engine') != 'none' else [],
+        'expression/expression_nary_test.cpp',
+        'expression/expression_object_test.cpp',
+        'expression/expression_or_test.cpp',
+        'expression/expression_replace_test.cpp',
+        'expression/expression_test.cpp',
+        'expression/expression_test_api_version_test.cpp',
+        'expression/expression_trigonometric_test.cpp',
+        'expression/expression_trim_test.cpp',
+        'expression/expression_walker_test.cpp',
         'field_path_test.cpp',
         'granularity_rounder_powers_of_two_test.cpp',
         'granularity_rounder_preferred_numbers_test.cpp',
@@ -543,7 +543,7 @@ env.CppUnitTest(
 env.Benchmark(
     target='expression_bm',
     source=[
-        'expression_bm.cpp',
+        'expression/expression_bm.cpp',
     ],
     LIBDEPS=[
         '$BUILD_DIR/mongo/db/query/query_test_service_context',
diff --git a/src/mongo/db/pipeline/accumulation_statement.cpp b/src/mongo/db/pipeline/accumulator/accumulation_statement.cpp
similarity index 97%
rename from src/mongo/db/pipeline/accumulation_statement.cpp
rename to src/mongo/db/pipeline/accumulator/accumulation_statement.cpp
index 77981c189c..0206a44ebd 100644
--- a/src/mongo/db/pipeline/accumulation_statement.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulation_statement.cpp
@@ -32,11 +32,11 @@
 #include <boost/intrusive_ptr.hpp>
 #include <string>
 
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 
 #include "mongo/db/commands/feature_compatibility_version_documentation.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/util/assert_util.h"
 #include "mongo/util/str.h"
 #include "mongo/util/string_map.h"
diff --git a/src/mongo/db/pipeline/accumulation_statement.h b/src/mongo/db/pipeline/accumulator/accumulation_statement.h
similarity index 98%
rename from src/mongo/db/pipeline/accumulation_statement.h
rename to src/mongo/db/pipeline/accumulator/accumulation_statement.h
index f621107421..c5b5c32519 100644
--- a/src/mongo/db/pipeline/accumulation_statement.h
+++ b/src/mongo/db/pipeline/accumulator/accumulation_statement.h
@@ -30,8 +30,8 @@
 #pragma once
 
 #include "mongo/bson/bsonelement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/accumulator.h b/src/mongo/db/pipeline/accumulator/accumulator.h
similarity index 99%
rename from src/mongo/db/pipeline/accumulator.h
rename to src/mongo/db/pipeline/accumulator/accumulator.h
index 0929a69656..4fb3d01274 100644
--- a/src/mongo/db/pipeline/accumulator.h
+++ b/src/mongo/db/pipeline/accumulator/accumulator.h
@@ -40,7 +40,7 @@
 #include "mongo/bson/bsontypes.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/exec/document_value/value_comparator.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/stdx/unordered_set.h"
 #include "mongo/util/summation.h"
diff --git a/src/mongo/db/pipeline/accumulator_add_to_set.cpp b/src/mongo/db/pipeline/accumulator/accumulator_add_to_set.cpp
similarity index 97%
rename from src/mongo/db/pipeline/accumulator_add_to_set.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_add_to_set.cpp
index 1538ca2f7e..abafc93a63 100644
--- a/src/mongo/db/pipeline/accumulator_add_to_set.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_add_to_set.cpp
@@ -29,10 +29,10 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/window_function/window_function_add_to_set.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
diff --git a/src/mongo/db/pipeline/accumulator_avg.cpp b/src/mongo/db/pipeline/accumulator/accumulator_avg.cpp
similarity index 96%
rename from src/mongo/db/pipeline/accumulator_avg.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_avg.cpp
index 201ee31c34..8317e24853 100644
--- a/src/mongo/db/pipeline/accumulator_avg.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_avg.cpp
@@ -29,12 +29,12 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/window_function/window_function_avg.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
diff --git a/src/mongo/db/pipeline/accumulator_covariance.cpp b/src/mongo/db/pipeline/accumulator/accumulator_covariance.cpp
similarity index 93%
rename from src/mongo/db/pipeline/accumulator_covariance.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_covariance.cpp
index 785698b115..28e41f88e0 100644
--- a/src/mongo/db/pipeline/accumulator_covariance.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_covariance.cpp
@@ -31,11 +31,11 @@
 
 #include <cmath>
 
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/accumulator_exp_moving_avg.cpp b/src/mongo/db/pipeline/accumulator/accumulator_exp_moving_avg.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_exp_moving_avg.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_exp_moving_avg.cpp
index 2f2dcc93d9..3d5cd7f513 100644
--- a/src/mongo/db/pipeline/accumulator_exp_moving_avg.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_exp_moving_avg.cpp
@@ -32,11 +32,11 @@
 #include <cmath>
 #include <limits>
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/accumulator_first.cpp b/src/mongo/db/pipeline/accumulator/accumulator_first.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_first.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_first.cpp
index cfb22aef24..5a1fab1dd7 100644
--- a/src/mongo/db/pipeline/accumulator_first.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_first.cpp
@@ -29,10 +29,10 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/accumulator_for_window_functions.h b/src/mongo/db/pipeline/accumulator/accumulator_for_window_functions.h
similarity index 99%
rename from src/mongo/db/pipeline/accumulator_for_window_functions.h
rename to src/mongo/db/pipeline/accumulator/accumulator_for_window_functions.h
index 058d45f62f..160487d9ca 100644
--- a/src/mongo/db/pipeline/accumulator_for_window_functions.h
+++ b/src/mongo/db/pipeline/accumulator/accumulator_for_window_functions.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/window_function/window_function_covariance.h"
 #include "mongo/db/pipeline/window_function/window_function_integral.h"
 
diff --git a/src/mongo/db/pipeline/accumulator_integral.cpp b/src/mongo/db/pipeline/accumulator/accumulator_integral.cpp
similarity index 93%
rename from src/mongo/db/pipeline/accumulator_integral.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_integral.cpp
index 83ba68c40d..a16d95339c 100644
--- a/src/mongo/db/pipeline/accumulator_integral.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_integral.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator_for_window_functions.h"
+#include "mongo/db/pipeline/accumulator/accumulator_for_window_functions.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/window_function/window_function_expression.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/accumulator_js_reduce.cpp b/src/mongo/db/pipeline/accumulator/accumulator_js_reduce.cpp
similarity index 99%
rename from src/mongo/db/pipeline/accumulator_js_reduce.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_js_reduce.cpp
index e7192465d7..71d1a25027 100644
--- a/src/mongo/db/pipeline/accumulator_js_reduce.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_js_reduce.cpp
@@ -30,7 +30,7 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/bson/bsonobjbuilder.h"
-#include "mongo/db/pipeline/accumulator_js_reduce.h"
+#include "mongo/db/pipeline/accumulator/accumulator_js_reduce.h"
 #include "mongo/db/pipeline/make_js_function.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/accumulator_js_reduce.h b/src/mongo/db/pipeline/accumulator/accumulator_js_reduce.h
similarity index 98%
rename from src/mongo/db/pipeline/accumulator_js_reduce.h
rename to src/mongo/db/pipeline/accumulator/accumulator_js_reduce.h
index f072505526..5d629c8b9d 100644
--- a/src/mongo/db/pipeline/accumulator_js_reduce.h
+++ b/src/mongo/db/pipeline/accumulator/accumulator_js_reduce.h
@@ -32,8 +32,8 @@
 #include <boost/intrusive_ptr.hpp>
 #include <vector>
 
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 #include "mongo/db/pipeline/expression_context.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/accumulator_js_test.cpp b/src/mongo/db/pipeline/accumulator/accumulator_js_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/accumulator_js_test.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_js_test.cpp
index 953b4ce475..4b3959d46f 100644
--- a/src/mongo/db/pipeline/accumulator_js_test.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_js_test.cpp
@@ -33,7 +33,7 @@
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/accumulator_js_reduce.h"
+#include "mongo/db/pipeline/accumulator/accumulator_js_reduce.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/pipeline/process_interface/standalone_process_interface.h"
 #include "mongo/db/service_context_d_test_fixture.h"
diff --git a/src/mongo/db/pipeline/accumulator_last.cpp b/src/mongo/db/pipeline/accumulator/accumulator_last.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_last.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_last.cpp
index a1dade1aef..f61847f577 100644
--- a/src/mongo/db/pipeline/accumulator_last.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_last.cpp
@@ -29,10 +29,10 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/accumulator_merge_objects.cpp b/src/mongo/db/pipeline/accumulator/accumulator_merge_objects.cpp
similarity index 95%
rename from src/mongo/db/pipeline/accumulator_merge_objects.cpp
rename to src/mongo/db/pipeline/accumulator/accumulator_merge_objects.cpp
index 8804a8a0f0..443e48e4b6 100644
--- a/src/mongo/db/pipeline/accumulator_merge_objects.cpp
+++ b/src/mongo/db/pipeline/accumulator/accumulator_merge_objects.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/accumulator.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
 
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
